=== modified file 'CMakeLists.txt'
--- CMakeLists.txt	2014-06-05 20:06:15 +0000
+++ CMakeLists.txt	2014-06-12 10:52:04 +0000
@@ -25,19 +25,19 @@
 )
 
 set(lxqtmount_HDRS
-    lxqtmount.h
-    rzmountproviders.h
+    mount.h
+    providers.h
 )
 
 set(lxqtmount_SRCS
-    lxqtmount.cpp
-    rzmountproviders.cpp
-    rzmountproviders_udisks2.cpp
+    mount.cpp
+    providers.cpp
+    providers_udisks2.cpp
 )
 
 set(lxqtmount_MOCS
-    lxqtmount.h
-    rzmountproviders.h
+    mount.h
+    providers.h
 )
 
 QT4_WRAP_CPP(lxqtmount_MOCS ${lxqtmount_MOCS})

=== removed file 'lxqtmount.cpp'
--- lxqtmount.cpp	2014-05-06 08:07:57 +0000
+++ lxqtmount.cpp	1970-01-01 00:00:00 +0000
@@ -1,152 +0,0 @@
-/* BEGIN_COMMON_COPYRIGHT_HEADER
- * (c)LGPL2+
- *
- * LXQt - The Lightweight Desktop Environment
- * http://lxqt.org
- *
- * Copyright: 2012 Razor team
- *            2013-2014 LXQt team
- * Authors:
- *   Alexander Sokoloff <sokoloff.a@gmail.com>
- *
- * This program or library is free software; you can redistribute it
- * and/or modify it under the terms of the GNU Lesser General Public
- * License as published by the Free Software Foundation; either
- * version 2.1 of the License, or (at your option) any later version.
- *
- * This library is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * Lesser General Public License for more details.
-
- * You should have received a copy of the GNU Lesser General
- * Public License along with this library; if not, write to the
- * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- * Boston, MA 02110-1301 USA
- *
- * END_COMMON_COPYRIGHT_HEADER */
-
-#include "lxqtmount.h"
-#include "rzmountproviders.h"
-#include <QtCore/QDebug>
-
-namespace LxQt {
-
-MountDevice::MountDevice():
-    QObject(0),
-    mIsValid(false),
-    mIsExternal(false),
-    mIsMounted(false),
-    mIsEjectable(false)
-{
-}
-
-QString MountDevice::sizeToString(qulonglong size)
-{
-    double n;
-    n = size / (1024.0 * 1024 * 1024);
-    if (n >= 1.0)
-        return QObject::tr("%1 GB").arg(n, 0, 'f', 1);
-
-    n = size / (1024.0 * 1024);
-    if (n >= 1.0)
-        return QObject::tr("%1 MB").arg(n, 0, 'f', 1);
-
-    n = size / (1024.0);
-    if (n >= 1.0)
-        return QObject::tr("%1 kB").arg(n, 0, 'f', 1);
-
-    return QObject::tr("%1 B").arg(size);
-}
-
-
-MountManager::MountManager(QObject *parent):
-    QObject(parent),
-    mProvider(0)
-{
-    mProvider = new UDisks2Provider(this);
-    if (!mProvider->isValid())
-    {
-        delete mProvider;
-        mProvider = 0;
-
-        mProvider = new UDiskProvider(this);
-        if (!mProvider->isValid())
-        {
-            delete mProvider;
-            mProvider = 0;
-        }
-    }
-
-    if (!mProvider)
-        return;
-
-
-    update();
-
-    connect(mProvider, SIGNAL(deviceAdded(LxQt::MountDevice*)),
-                 this, SIGNAL(deviceAdded(LxQt::MountDevice*)));
-
-    connect(mProvider, SIGNAL(deviceChanged(LxQt::MountDevice*)),
-                 this, SIGNAL(deviceChanged(LxQt::MountDevice*)));
-
-    connect(mProvider, SIGNAL(deviceRemoved(LxQt::MountDevice*)),
-                 this, SIGNAL(deviceRemoved(LxQt::MountDevice*)));
-}
-
-
-MountManager::~MountManager()
-{
-    delete mProvider;
-}
-
-
-void MountManager::update()
-{
-    if (mProvider)
-        mProvider->update();
-    else
-        qDebug() << "MountDeviceList MountManager::update() no valid provider in use";
-
-}
-
-
-const MountDeviceList MountManager::devices() const
-{
-    if (mProvider)
-    {
-        //qDebug() << "MountManager::devices" << mProvider->devices();
-        return mProvider->devices();
-    }
-    else
-    {
-        qWarning() << "MountDeviceList MountManager::devices() no valid provider in use";
-        return MountDeviceList();
-    }
-}
-
-} // namespace LxQt
-
-QDebug operator<<(QDebug dbg, const LxQt::MountDevice &device)
-{
-    dbg << device.devFile();
-
-    switch (device.mediaType())
-    {
-    case LxQt::MountDevice::MediaTypeUnknown:    dbg<<"Type: MediaTypeUnknown";  break;
-    case LxQt::MountDevice::MediaTypeDrive:      dbg<<"Type: MediaTypeDrive";    break;
-    case LxQt::MountDevice::MediaTypePartition:  dbg<<"Type: MediaTypePartition";break;
-    case LxQt::MountDevice::MediaTypeFdd:        dbg<<"Type: MediaTypeFdd";      break;
-    case LxQt::MountDevice::MediaTypeOptical:    dbg<<"Type: MediaTypeOptical";  break;
-    default:                                    dbg<<"Type: "<<device.mediaType();break;
-    }
-    dbg << "Label: " << device.label();
-    dbg << "Mount path:" << device.mountPath();
-    return dbg.space();
-}
-
-
-QDebug operator<<(QDebug dbg, const LxQt::MountDevice *device)
-{
-    return operator<<(dbg, *device);
-}

=== removed file 'lxqtmount.h'
--- lxqtmount.h	2014-05-06 08:07:57 +0000
+++ lxqtmount.h	1970-01-01 00:00:00 +0000
@@ -1,161 +0,0 @@
-/* BEGIN_COMMON_COPYRIGHT_HEADER
- * (c)LGPL2+
- *
- * LXQt - The Lightweight Desktop Environment
- * http://lxqt.org
- *
- * Copyright: 2012 Razor team
- *            2013-2014 LXQt team
- * Authors:
- *   Alexander Sokoloff <sokoloff.a@gmail.com>
- *
- * This program or library is free software; you can redistribute it
- * and/or modify it under the terms of the GNU Lesser General Public
- * License as published by the Free Software Foundation; either
- * version 2.1 of the License, or (at your option) any later version.
- *
- * This library is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * Lesser General Public License for more details.
-
- * You should have received a copy of the GNU Lesser General
- * Public License along with this library; if not, write to the
- * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- * Boston, MA 02110-1301 USA
- *
- * END_COMMON_COPYRIGHT_HEADER */
-
-
-#ifndef LXQTMOUNT_LXQTMOUNT_H
-#define LXQTMOUNT_LXQTMOUNT_H
-
-#include <QtCore/QObject>
-#include <QtCore/QList>
-
-#include <QtGlobal>
-
-#ifdef COMPILE_LIBLXQT_MOUNT
-#define LIBLXQT_MOUNT_API Q_DECL_EXPORT
-#else
-#define LIBLXQT_MOUNT_API Q_DECL_IMPORT
-#endif
-
-#define BOOL_SETTER(MEMBER) { bool res=(value != MEMBER); MEMBER = value; return res; }
-
-namespace LxQt {
-
-class MountProvider;
-class LIBLXQT_MOUNT_API MountDevice: public QObject
-{
-    Q_OBJECT
-public:
-    enum MediaType {
-        MediaTypeUnknown,
-        MediaTypeDrive,
-        MediaTypePartition,
-        MediaTypeFdd,
-        MediaTypeOptical
-    };
-
-    virtual bool mount() = 0;
-    virtual bool unmount() = 0;
-    virtual bool eject() = 0;
-
-    QString devFile() const { return mDevFile; }
-    QString label() const { return mLabel; }
-    QString vendor() const { return mVendor; }
-    QString model() const { return mModel; }
-    QString fileSystem() const { return mFileSystem; }
-    QString mountPath() const { return mMountPath; }
-    QString iconName() const { return mIconName; }
-
-
-    qulonglong size() const { return mSize; }
-    MediaType mediaType() const { return mMediaType; }
-
-    bool isValid() const { return mIsValid; }
-    bool isExternal() const { return mIsExternal; }
-    bool isMounted() const { return mIsMounted; }
-    bool isEjectable() const { return mIsEjectable; }
-
-    static QString sizeToString(qulonglong size);
-signals:
-     void changed();
-     void error(const QString &msg);
-     void mounted();
-     void unmounted();
-
-protected:
-    explicit MountDevice();
-
-    bool setDevFile(const QString &value)   BOOL_SETTER(mDevFile)
-    bool setLabel(const QString &value)     BOOL_SETTER(mLabel)
-    bool setVendor(const QString &value)    BOOL_SETTER(mVendor)
-    bool setModel(const QString &value)     BOOL_SETTER(mModel)
-    bool setFileSystem(const QString &value) BOOL_SETTER(mFileSystem)
-    bool setMountPath(const QString &value) BOOL_SETTER(mMountPath)
-    bool setIconName(const QString &value)  BOOL_SETTER(mIconName)
-
-    bool setSize(qulonglong value)      BOOL_SETTER(mSize)
-    bool setMediaType(MediaType value)  BOOL_SETTER(mMediaType)
-
-    bool setIsValid(bool value)         BOOL_SETTER(mIsValid)
-    bool setIsExternal(bool value)      BOOL_SETTER(mIsExternal)
-    bool setIsMounted(bool value)       BOOL_SETTER(mIsMounted)
-    bool setIsEjectable(bool value)     BOOL_SETTER(mIsEjectable)
-
-    QString mDevFile;
-    QString mLabel;
-    QString mVendor;
-    QString mModel;
-    QString mFileSystem;
-    QString mMountPath;
-    QString mIconName;
-
-    qulonglong mSize;
-    MediaType mMediaType;
-
-    bool mIsValid;
-    bool mIsExternal;
-    bool mIsMounted;
-    bool mIsEjectable;
-private:
-    Q_DISABLE_COPY(MountDevice)
-
-
-};
-
-typedef QList<MountDevice*> MountDeviceList;
-
-
-
-
-class LIBLXQT_MOUNT_API MountManager : public QObject
-{
-    Q_OBJECT
-public:
-    explicit MountManager(QObject *parent = 0);
-    virtual ~MountManager();
-
-    const MountDeviceList devices() const;
-
-public slots:
-    void update();
-
-signals:
-    void deviceAdded(LxQt::MountDevice *device);
-    void deviceRemoved(LxQt::MountDevice *device);
-    void deviceChanged(LxQt::MountDevice *device);
-
-private:
-    MountProvider *mProvider;
-
-};
-
-} // namespace LxQt
-
-LIBLXQT_MOUNT_API QDebug operator<<(QDebug dbg, const LxQt::MountDevice& device);
-LIBLXQT_MOUNT_API QDebug operator<<(QDebug dbg, const LxQt::MountDevice* const device);
-
-#endif // LXQTMOUNT_LXQTMOUNT_H

=== added file 'mount.cpp'
--- mount.cpp	1970-01-01 00:00:00 +0000
+++ mount.cpp	2014-06-12 10:52:04 +0000
@@ -0,0 +1,152 @@
+/* BEGIN_COMMON_COPYRIGHT_HEADER
+ * (c)LGPL2+
+ *
+ * LXQt - The Lightweight Desktop Environment
+ * http://lxqt.org
+ *
+ * Copyright: 2012 Razor team
+ *            2013-2014 LXQt team
+ * Authors:
+ *   Alexander Sokoloff <sokoloff.a@gmail.com>
+ *
+ * This program or library is free software; you can redistribute it
+ * and/or modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+
+ * You should have received a copy of the GNU Lesser General
+ * Public License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301 USA
+ *
+ * END_COMMON_COPYRIGHT_HEADER */
+
+#include "mount.h"
+#include "providers.h"
+#include <QtCore/QDebug>
+
+namespace LxQt {
+
+MountDevice::MountDevice():
+    QObject(0),
+    mIsValid(false),
+    mIsExternal(false),
+    mIsMounted(false),
+    mIsEjectable(false)
+{
+}
+
+QString MountDevice::sizeToString(qulonglong size)
+{
+    double n;
+    n = size / (1024.0 * 1024 * 1024);
+    if (n >= 1.0)
+        return QObject::tr("%1 GB").arg(n, 0, 'f', 1);
+
+    n = size / (1024.0 * 1024);
+    if (n >= 1.0)
+        return QObject::tr("%1 MB").arg(n, 0, 'f', 1);
+
+    n = size / (1024.0);
+    if (n >= 1.0)
+        return QObject::tr("%1 kB").arg(n, 0, 'f', 1);
+
+    return QObject::tr("%1 B").arg(size);
+}
+
+
+MountManager::MountManager(QObject *parent):
+    QObject(parent),
+    mProvider(0)
+{
+    mProvider = new UDisks2Provider(this);
+    if (!mProvider->isValid())
+    {
+        delete mProvider;
+        mProvider = 0;
+
+        mProvider = new UDiskProvider(this);
+        if (!mProvider->isValid())
+        {
+            delete mProvider;
+            mProvider = 0;
+        }
+    }
+
+    if (!mProvider)
+        return;
+
+
+    update();
+
+    connect(mProvider, SIGNAL(deviceAdded(LxQt::MountDevice*)),
+                 this, SIGNAL(deviceAdded(LxQt::MountDevice*)));
+
+    connect(mProvider, SIGNAL(deviceChanged(LxQt::MountDevice*)),
+                 this, SIGNAL(deviceChanged(LxQt::MountDevice*)));
+
+    connect(mProvider, SIGNAL(deviceRemoved(LxQt::MountDevice*)),
+                 this, SIGNAL(deviceRemoved(LxQt::MountDevice*)));
+}
+
+
+MountManager::~MountManager()
+{
+    delete mProvider;
+}
+
+
+void MountManager::update()
+{
+    if (mProvider)
+        mProvider->update();
+    else
+        qDebug() << "MountDeviceList MountManager::update() no valid provider in use";
+
+}
+
+
+const MountDeviceList MountManager::devices() const
+{
+    if (mProvider)
+    {
+        //qDebug() << "MountManager::devices" << mProvider->devices();
+        return mProvider->devices();
+    }
+    else
+    {
+        qWarning() << "MountDeviceList MountManager::devices() no valid provider in use";
+        return MountDeviceList();
+    }
+}
+
+} // namespace LxQt
+
+QDebug operator<<(QDebug dbg, const LxQt::MountDevice &device)
+{
+    dbg << device.devFile();
+
+    switch (device.mediaType())
+    {
+    case LxQt::MountDevice::MediaTypeUnknown:    dbg<<"Type: MediaTypeUnknown";  break;
+    case LxQt::MountDevice::MediaTypeDrive:      dbg<<"Type: MediaTypeDrive";    break;
+    case LxQt::MountDevice::MediaTypePartition:  dbg<<"Type: MediaTypePartition";break;
+    case LxQt::MountDevice::MediaTypeFdd:        dbg<<"Type: MediaTypeFdd";      break;
+    case LxQt::MountDevice::MediaTypeOptical:    dbg<<"Type: MediaTypeOptical";  break;
+    default:                                    dbg<<"Type: "<<device.mediaType();break;
+    }
+    dbg << "Label: " << device.label();
+    dbg << "Mount path:" << device.mountPath();
+    return dbg.space();
+}
+
+
+QDebug operator<<(QDebug dbg, const LxQt::MountDevice *device)
+{
+    return operator<<(dbg, *device);
+}

=== added file 'mount.h'
--- mount.h	1970-01-01 00:00:00 +0000
+++ mount.h	2014-06-12 10:52:04 +0000
@@ -0,0 +1,161 @@
+/* BEGIN_COMMON_COPYRIGHT_HEADER
+ * (c)LGPL2+
+ *
+ * LXQt - The Lightweight Desktop Environment
+ * http://lxqt.org
+ *
+ * Copyright: 2012 Razor team
+ *            2013-2014 LXQt team
+ * Authors:
+ *   Alexander Sokoloff <sokoloff.a@gmail.com>
+ *
+ * This program or library is free software; you can redistribute it
+ * and/or modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+
+ * You should have received a copy of the GNU Lesser General
+ * Public License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301 USA
+ *
+ * END_COMMON_COPYRIGHT_HEADER */
+
+
+#ifndef LXQTMOUNT_LXQTMOUNT_H
+#define LXQTMOUNT_LXQTMOUNT_H
+
+#include <QtCore/QObject>
+#include <QtCore/QList>
+
+#include <QtGlobal>
+
+#ifdef COMPILE_LIBLXQT_MOUNT
+#define LIBLXQT_MOUNT_API Q_DECL_EXPORT
+#else
+#define LIBLXQT_MOUNT_API Q_DECL_IMPORT
+#endif
+
+#define BOOL_SETTER(MEMBER) { bool res=(value != MEMBER); MEMBER = value; return res; }
+
+namespace LxQt {
+
+class MountProvider;
+class LIBLXQT_MOUNT_API MountDevice: public QObject
+{
+    Q_OBJECT
+public:
+    enum MediaType {
+        MediaTypeUnknown,
+        MediaTypeDrive,
+        MediaTypePartition,
+        MediaTypeFdd,
+        MediaTypeOptical
+    };
+
+    virtual bool mount() = 0;
+    virtual bool unmount() = 0;
+    virtual bool eject() = 0;
+
+    QString devFile() const { return mDevFile; }
+    QString label() const { return mLabel; }
+    QString vendor() const { return mVendor; }
+    QString model() const { return mModel; }
+    QString fileSystem() const { return mFileSystem; }
+    QString mountPath() const { return mMountPath; }
+    QString iconName() const { return mIconName; }
+
+
+    qulonglong size() const { return mSize; }
+    MediaType mediaType() const { return mMediaType; }
+
+    bool isValid() const { return mIsValid; }
+    bool isExternal() const { return mIsExternal; }
+    bool isMounted() const { return mIsMounted; }
+    bool isEjectable() const { return mIsEjectable; }
+
+    static QString sizeToString(qulonglong size);
+signals:
+     void changed();
+     void error(const QString &msg);
+     void mounted();
+     void unmounted();
+
+protected:
+    explicit MountDevice();
+
+    bool setDevFile(const QString &value)   BOOL_SETTER(mDevFile)
+    bool setLabel(const QString &value)     BOOL_SETTER(mLabel)
+    bool setVendor(const QString &value)    BOOL_SETTER(mVendor)
+    bool setModel(const QString &value)     BOOL_SETTER(mModel)
+    bool setFileSystem(const QString &value) BOOL_SETTER(mFileSystem)
+    bool setMountPath(const QString &value) BOOL_SETTER(mMountPath)
+    bool setIconName(const QString &value)  BOOL_SETTER(mIconName)
+
+    bool setSize(qulonglong value)      BOOL_SETTER(mSize)
+    bool setMediaType(MediaType value)  BOOL_SETTER(mMediaType)
+
+    bool setIsValid(bool value)         BOOL_SETTER(mIsValid)
+    bool setIsExternal(bool value)      BOOL_SETTER(mIsExternal)
+    bool setIsMounted(bool value)       BOOL_SETTER(mIsMounted)
+    bool setIsEjectable(bool value)     BOOL_SETTER(mIsEjectable)
+
+    QString mDevFile;
+    QString mLabel;
+    QString mVendor;
+    QString mModel;
+    QString mFileSystem;
+    QString mMountPath;
+    QString mIconName;
+
+    qulonglong mSize;
+    MediaType mMediaType;
+
+    bool mIsValid;
+    bool mIsExternal;
+    bool mIsMounted;
+    bool mIsEjectable;
+private:
+    Q_DISABLE_COPY(MountDevice)
+
+
+};
+
+typedef QList<MountDevice*> MountDeviceList;
+
+
+
+
+class LIBLXQT_MOUNT_API MountManager : public QObject
+{
+    Q_OBJECT
+public:
+    explicit MountManager(QObject *parent = 0);
+    virtual ~MountManager();
+
+    const MountDeviceList devices() const;
+
+public slots:
+    void update();
+
+signals:
+    void deviceAdded(LxQt::MountDevice *device);
+    void deviceRemoved(LxQt::MountDevice *device);
+    void deviceChanged(LxQt::MountDevice *device);
+
+private:
+    MountProvider *mProvider;
+
+};
+
+} // namespace LxQt
+
+LIBLXQT_MOUNT_API QDebug operator<<(QDebug dbg, const LxQt::MountDevice& device);
+LIBLXQT_MOUNT_API QDebug operator<<(QDebug dbg, const LxQt::MountDevice* const device);
+
+#endif // LXQTMOUNT_LXQTMOUNT_H

=== added file 'providers.cpp'
--- providers.cpp	1970-01-01 00:00:00 +0000
+++ providers.cpp	2014-06-12 10:52:04 +0000
@@ -0,0 +1,511 @@
+/* BEGIN_COMMON_COPYRIGHT_HEADER
+ * (c)LGPL2+
+ *
+ * LXQt - The Lightweight Desktop Environment
+ * http://lxqt.org
+ *
+ * Copyright: 2012 Razor team
+ *            2013-2014 LXQt team
+ * Authors:
+ *   Alexander Sokoloff <sokoloff.a@gmail.com>
+ *   Petr Vanek <petr@scribus.info>
+ *
+ * This program or library is free software; you can redistribute it
+ * and/or modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+
+ * You should have received a copy of the GNU Lesser General
+ * Public License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301 USA
+ *
+ * END_COMMON_COPYRIGHT_HEADER */
+
+#include "providers.h"
+#include <QtDBus/QDBusConnection>
+#include <QtDBus/QDBusArgument>
+#include <QtDBus/QDBusInterface>
+#include <QtDBus/QDBusMessage>
+#include <QtCore/QDebug>
+
+namespace LxQt {
+
+/************************************************
+
+ ************************************************/
+MountProvider::MountProvider(QObject *parent):
+    QObject(parent),
+    mIsValid(false)
+{
+}
+
+
+/************************************************
+
+ ************************************************/
+UDiskProvider::UDiskProvider(QObject *parent):
+    MountProvider(parent)
+{
+    QDBusConnection system = QDBusConnection::systemBus();
+
+    if (!system.isConnected())
+    {
+        return;
+    }
+
+    if (!QDBusInterface("org.freedesktop.UDisks",
+                       "/org/freedesktop/UDisks",
+                       "org.freedesktop.UDisks", system).isValid())
+    {
+        qDebug() << "org.freedesktop.UDisks - not exists - " << mIsValid;
+        return;
+    }
+
+    system.connect("org.freedesktop.UDisks",
+                   "/org/freedesktop/UDisks",
+                   "org.freedesktop.UDisks",
+                   "DeviceAdded",
+                   this,
+                   SLOT(dbusDeviceAdded(QDBusObjectPath)));
+
+    system.connect("org.freedesktop.UDisks",
+                   "/org/freedesktop/UDisks",
+                   "org.freedesktop.UDisks",
+                   "DeviceRemoved",
+                   this,
+                   SLOT(dbusDeviceRemoved(QDBusObjectPath)));
+
+    system.connect("org.freedesktop.UDisks",
+                   "/org/freedesktop/UDisks",
+                   "org.freedesktop.UDisks",
+                   "DeviceChanged",
+                   this,
+                   SLOT(dbusDeviceChanged(QDBusObjectPath)));
+
+    mIsValid = true;
+}
+
+
+/************************************************
+
+ ************************************************/
+void UDiskProvider::update()
+{
+
+    QDBusInterface devEnum("org.freedesktop.UDisks",
+                           "/org/freedesktop/UDisks",
+                           "org.freedesktop.UDisks",
+                           QDBusConnection::systemBus());
+
+    QDBusMessage enumRes = devEnum.call("EnumerateDevices");
+    if (enumRes.type() != QDBusMessage::ReplyMessage || !enumRes.arguments().at(0).canConvert<QDBusArgument>())
+    {
+        if (enumRes.type() == QDBusMessage::ErrorMessage)
+            qWarning() << "ERROR: Can't call EnumerateDevices"
+                       <<  qPrintable(enumRes.errorName()) << qPrintable(enumRes.errorMessage());
+        else
+            qWarning() << "ERROR: Unexpected result type of EnumerateDevices call";
+        return;
+    }
+
+    const QDBusArgument enumArg = enumRes.arguments().at(0).value<QDBusArgument>();
+    if (enumArg.currentType() != QDBusArgument::ArrayType)
+    {
+        qWarning() << "ERROR: Unexpected argument type of EnumerateDevices call";
+        return;
+    }
+
+    enumArg.beginArray();
+    while (!enumArg.atEnd())
+    {
+        QDBusObjectPath path = qdbus_cast<QDBusObjectPath>(enumArg);
+
+        if (mDevicesByPath.contains(path.path()))
+            dbusDeviceChanged(path);
+        else
+            dbusDeviceAdded(path);
+    }
+    enumArg.endArray();
+
+}
+
+
+/************************************************
+
+ ************************************************/
+UDiskMountDevice *UDiskProvider::getDevice(const QDBusObjectPath &path) const
+{
+    if (mDevicesByPath.contains(path.path()))
+        return mDevicesByPath[path.path()];
+    else
+        return 0;
+}
+
+
+/************************************************
+
+ ************************************************/
+void UDiskProvider::addDevice(UDiskMountDevice *device)
+{
+    mDevicesByPath.insert(device->udiskPath(), device);
+    mDevices.append(device);
+}
+
+
+/************************************************
+
+ ************************************************/
+void UDiskProvider::delDevice(UDiskMountDevice *device)
+{
+    mDevices.removeAll(device);
+    mDevicesByPath.remove(device->udiskPath());
+    device->deleteLater();
+}
+
+
+/************************************************
+
+ ************************************************/
+void UDiskProvider::dbusDeviceAdded(const QDBusObjectPath &path)
+{
+    UDiskMountDevice *device = new UDiskMountDevice(path);
+     addDevice(device);
+     emit deviceAdded(device);
+}
+
+
+/************************************************
+
+ ************************************************/
+void UDiskProvider::dbusDeviceRemoved(const QDBusObjectPath &path)
+{
+    UDiskMountDevice *device = getDevice(path);
+    if (device)
+    {
+        emit deviceRemoved(device);
+        delDevice(device);
+    }
+}
+
+
+/************************************************
+
+ ************************************************/
+void UDiskProvider::dbusDeviceChanged(const QDBusObjectPath &path)
+{
+    UDiskMountDevice *device = getDevice(path);
+    if (!device)
+        return;
+
+    if (device->update())
+        emit deviceChanged(device);
+}
+
+
+/************************************************
+
+ ************************************************/
+UDiskMountDevice::UDiskMountDevice(const QDBusObjectPath &path):
+    MountDevice(),
+    mUdiskPath(path.path())
+{
+    mDbus = new QDBusInterface("org.freedesktop.UDisks",
+                               path.path(),
+                               "org.freedesktop.UDisks.Device",
+                               QDBusConnection::systemBus(),
+                               this);
+    update();
+}
+
+
+/************************************************
+
+ ************************************************/
+bool UDiskMountDevice::update()
+{
+    bool res = false;
+    res = setDevFile(mDbus->property("DeviceFile").toString()) || res;
+
+    res = setMediaType(calcMediaType()) || res;
+    res = setLabel(calcLabel()) || res;
+    res = setIsExternal(calcIsExternal()) || res;
+    res = setIconName(calcIconName()) || res;
+
+    res = setIsMounted(mDbus->property("DeviceIsMounted").toBool()) || res;
+
+    if (mDbus->property("DeviceIsDrive").toBool())
+        res = setIsEjectable(mDbus->property("DriveIsMediaEjectable").toBool());
+
+    res = setSize(mDbus->property("DeviceSize").toULongLong()) || res;
+    res = setVendor(mDbus->property("DriveVendor").toString()) || res;
+    res = setModel(mDbus->property("DriveModel").toString()) || res;
+    res = setFileSystem(mDbus->property("IdType").toString()) || res;
+
+    QStringList paths = mDbus->property("DeviceMountPaths").toStringList();
+    if (!paths.empty())
+        res = setMountPath(paths.first()) || res;
+
+    if (res)
+        emit changed();
+
+    return res;
+}
+
+
+/************************************************
+
+ ************************************************/
+MountDevice::MediaType UDiskMountDevice::calcMediaType()
+{
+    if (mDbus->property("DeviceIsOpticalDisc").toBool())
+        return MountDevice::MediaTypeOptical;
+
+    const QString media = mDbus->property("DriveMedia").toString();
+    const QString mediaCompat = mDbus->property("DriveMediaCompatibility").toString();
+    const QString idUsage = mDbus->property("IdUsage").toString();
+
+    if (mDbus->property("DeviceIsDrive").toBool())
+    {
+        if (mediaCompat == "floppy")
+            return MountDevice::MediaTypeFdd;
+
+        if (idUsage == "filesystem")
+            return MountDevice::MediaTypeDrive;
+
+        return MountDevice::MediaTypeUnknown;
+    }
+
+    if (mDbus->property("DeviceIsPartition").toBool())
+    {
+        if (idUsage == "filesystem")
+            return MountDevice::MediaTypePartition;
+
+        return MountDevice::MediaTypeUnknown;
+    }
+
+    return MountDevice::MediaTypeUnknown;
+}
+
+
+/************************************************
+
+ ************************************************/
+QString UDiskMountDevice::calcLabel()
+{
+    const QString idLabel = mDbus->property("IdLabel").toString();
+
+    if (mMediaType ==  MediaTypeFdd)
+        return tr("Floppy drive");
+
+    if (mMediaType ==  MediaTypeOptical)
+        return idLabel;
+
+
+    const QString driveVendor = mDbus->property("DriveVendor").toString();
+    const QString driveModel  = mDbus->property("DriveModel").toString();
+    const qulonglong size = mDbus->property("DeviceSize").toULongLong();
+
+    QString label;
+    if (!idLabel.isEmpty())
+    {
+        label = idLabel;
+    }
+    else
+    {
+       if (!driveVendor.isEmpty())
+            label = driveVendor;
+
+       if (!driveModel.isEmpty())
+            label += QString(" - %1").arg(driveModel);
+    }
+
+    if (label.isEmpty())
+        label = mDevFile;
+
+    if (mSize)
+        label += QString(" [%3]").arg(sizeToString(size));
+
+    return label;
+}
+
+
+/************************************************
+
+ ************************************************/
+bool UDiskMountDevice::calcIsExternal()
+{
+    return ! mDbus->property("DeviceIsSystemInternal").toBool();
+//    if (mDbus->property("DeviceIsSystemInternal").toBool())
+//        return false;
+
+//    if (mDbus->property("DeviceIsMediaAvailable").toBool()
+//        && mDbus->property("IdUsage").toString() == "filesystem")
+//        return true;
+
+//    if (mDbus->property("DeviceIsDrive").toBool())
+//    {
+//        return true;
+//    }
+
+ //   return false;
+}
+
+
+/************************************************
+
+ ************************************************/
+QString UDiskMountDevice::calcIconName()
+{
+    const QString media = mDbus->property( "DriveMedia" ).toString();
+
+    switch (mMediaType)
+    {
+    // ..............................................
+    case MediaTypeDrive:
+    case MediaTypePartition:
+        {
+            // handle drives
+            const QString conn = mDbus->property( "DriveConnectionInterface" ).toString();
+
+            if (conn == "usb")
+                return "drive-removable-media-usb";
+
+            return "drive-removable-media";
+        }
+
+    // ..............................................
+    case MediaTypeFdd:
+        {
+            return "media-floppy";
+        }
+
+
+    // ..............................................
+//    case MediaTypeFlash:
+//        {
+//            if ( media == "flash_ms" ) // Flash & Co.
+//                return "media-flash-memory-stick";
+
+//            if ( media == "flash_sd" ||
+//                 media == "flash_sdhc" ||
+//                 media == "flash_mmc" )
+//                return "media-flash-sd-mmc";
+
+//            if ( media == "flash_sm" )
+//                return "media-flash-smart-media";
+
+//            return "media-flash";
+//        }
+
+
+    // ..............................................
+    case MediaTypeOptical:
+        {
+            bool isWritable = mDbus->property( "OpticalDiscIsBlank" ).toBool() ||
+                              mDbus->property("OpticalDiscIsAppendable").toBool();
+
+            if (isWritable)
+                return "media-optical-recordable";
+
+            if (media.startsWith("optical_dvd") ||
+                media.startsWith( "optical_hddvd")) // DVD
+                return "media-optical-dvd";
+
+            if (media.startsWith("optical_bd")) // BluRay
+                return "media-optical-blu-ray";
+
+            return "media-optical";
+        }
+
+    // ..............................................
+    case MediaTypeUnknown:
+        {
+            return "drive-harddisk";
+        }
+    }
+
+     return "drive-harddisk";
+}
+
+
+/************************************************
+
+ ************************************************/
+void UDiskMountDevice::dbusError(const QDBusError &err, const QDBusMessage &msg)
+{
+    qWarning() << "UdisksInfo::mDbus_error" << err.message();
+    emit error(err.message());
+}
+
+
+/************************************************
+
+ ************************************************/
+bool UDiskMountDevice::mount()
+{
+    if (mIsMounted)
+        return true;
+
+    QList<QVariant> args;
+    args << QVariant(QString()) << QVariant(QStringList());
+
+    bool ret;
+    ret = mDbus->callWithCallback("FilesystemMount", args, this,
+                             //SLOT(dbusSuccess(QDBusMessage)),
+                             SIGNAL(mounted()),
+                             SLOT(dbusError(QDBusError, QDBusMessage)));
+
+    QStringList paths = mDbus->property("DeviceMountPaths").toStringList();
+
+    if (!paths.empty())
+        mMountPath = paths.at(0);
+    else
+        mMountPath = "";
+
+    return ret;
+}
+
+
+/************************************************
+
+ ************************************************/
+bool UDiskMountDevice::unmount()
+{
+    if (!mIsMounted)
+        return true;
+
+    QList<QVariant> args;
+    args << QVariant(QStringList());
+
+    bool ret;
+    ret = mDbus->callWithCallback("FilesystemUnmount", args, this,
+//                             SLOT(dbusSuccess(QDBusMessage)),
+                             SIGNAL(unmounted()),
+                             SLOT(dbusError(QDBusError, QDBusMessage)));
+    return ret;
+}
+
+
+/************************************************
+
+ ************************************************/
+bool UDiskMountDevice::eject()
+{
+    if (!mIsMounted)
+        return false;
+
+    QList<QVariant> args;
+    args << QVariant(QStringList());
+
+    return mDbus->callWithCallback("DriveEject", args, this,
+                             SLOT(dbusSuccess(QDBusMessage)),
+                             SLOT(dbusError(QDBusError, QDBusMessage)));
+}
+
+} // namespace LxQt

=== added file 'providers.h'
--- providers.h	1970-01-01 00:00:00 +0000
+++ providers.h	2014-06-12 10:52:04 +0000
@@ -0,0 +1,175 @@
+/* BEGIN_COMMON_COPYRIGHT_HEADER
+ * (c)LGPL2+
+ *
+ * LXQt - The Lightweight Desktop Environment
+ * http://lxqt.org
+ *
+ * Copyright: 2012 Razor team
+ *            2013-2014 LXQt team
+ * Authors:
+ *   Alexander Sokoloff <sokoloff.a@gmail.com>
+ *   Petr Vanek <petr@scribus.info>
+ *
+ * This program or library is free software; you can redistribute it
+ * and/or modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+
+ * You should have received a copy of the GNU Lesser General
+ * Public License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301 USA
+ *
+ * END_COMMON_COPYRIGHT_HEADER */
+
+
+#ifndef LXQTMOUNT_RZMOUNTPROVIDERS_H
+#define LXQTMOUNT_RZMOUNTPROVIDERS_H
+
+#include <QObject>
+#include "mount.h"
+#include <QtDBus/QDBusObjectPath>
+class QDBusInterface;
+class QDBusMessage;
+class QDBusError;
+
+namespace LxQt {
+
+class MountProvider : public QObject
+{
+    Q_OBJECT
+public:
+    explicit MountProvider(QObject *parent = 0);
+    virtual ~MountProvider() {}
+
+    const MountDeviceList devices() const { return mDevices; }
+
+    bool isValid() const { return mIsValid; }
+    virtual void update()=0;
+
+signals:
+    void deviceAdded(LxQt::MountDevice *device);
+    void deviceRemoved(LxQt::MountDevice *device);
+    void deviceChanged(LxQt::MountDevice *device);
+
+protected:
+    MountDeviceList mDevices;
+    bool mIsValid;
+};
+
+
+
+class UDiskMountDevice: public MountDevice
+{
+    Q_OBJECT
+public:
+    UDiskMountDevice(const QDBusObjectPath &path);
+    bool update();
+    QString udiskPath() const { return mUdiskPath; }
+
+    virtual bool mount();
+    virtual bool unmount();
+    virtual bool eject();
+
+private:
+    QDBusInterface *mDbus;
+    QString mUdiskPath;
+
+    MediaType calcMediaType();
+    QString calcLabel();
+    bool calcIsExternal();
+    QString calcIconName();
+
+private slots:
+    void dbusError(const QDBusError &err, const QDBusMessage &msg);
+};
+
+
+
+class UDiskProvider: public MountProvider
+{
+    Q_OBJECT
+public:
+    explicit UDiskProvider(QObject *parent = 0);
+
+    virtual void update();
+
+private slots:
+    void dbusDeviceAdded(const QDBusObjectPath &path);
+    void dbusDeviceRemoved(const QDBusObjectPath &path);
+    void dbusDeviceChanged(const QDBusObjectPath &path);
+
+private:
+    QHash<QString, UDiskMountDevice*> mDevicesByPath;
+    UDiskMountDevice *getDevice(const QDBusObjectPath &path) const;
+
+    void addDevice(UDiskMountDevice *device);
+    void delDevice(UDiskMountDevice *device);
+};
+
+
+
+class UDisks2MountDevice: public MountDevice
+{
+    Q_OBJECT
+public:
+    UDisks2MountDevice(const QDBusObjectPath &path);
+    QDBusObjectPath path() { return mPath; }
+
+    virtual bool mount();
+    virtual bool unmount();
+    virtual bool eject();
+
+private:
+    QDBusInterface *mBlockIface;
+    QDBusInterface *mDriveIface;
+    QDBusObjectPath mPath;
+
+    MediaType calcMediaType();
+    QString calcLabel();
+    bool calcIsExternal();
+    QString calcIconName();
+    QStringList mountPoints() const;
+
+
+private slots:
+    void dbusError(const QDBusError &err, const QDBusMessage &msg);
+    void aboutToMount();
+    void aboutToUnmount();
+    void aboutToEject();
+    void update();
+};
+
+
+
+class UDisks2Provider: public MountProvider
+{
+    Q_OBJECT
+public:
+    explicit UDisks2Provider(QObject *parent = 0);
+
+    virtual void update();
+
+public slots:
+    void dbusDeviceChanged(const QDBusObjectPath &path);
+
+private slots:
+    void dbusDeviceAdded(const QDBusObjectPath &path, const QVariantMap &map);
+    void dbusDeviceRemoved(const QDBusObjectPath &path, const QStringList &list);
+
+private:
+    QHash<QString, UDisks2MountDevice*> mDevicesByPath;
+    UDisks2MountDevice *getDevice(const QDBusObjectPath &path) const;
+
+    void addDevice(UDisks2MountDevice *device);
+    void delDevice(UDisks2MountDevice *device);
+};
+
+} // namespace LxQt
+
+#endif // LXQTMOUNT_RZMOUNTPROVIDERS_H

=== added file 'providers_udisks2.cpp'
--- providers_udisks2.cpp	1970-01-01 00:00:00 +0000
+++ providers_udisks2.cpp	2014-06-12 10:52:04 +0000
@@ -0,0 +1,490 @@
+/* BEGIN_COMMON_COPYRIGHT_HEADER
+ * (c)LGPL2+
+ *
+ * LXQt - The Lightweight Desktop Environment
+ * http://lxqt.org
+ *
+ * Copyright: 2013 Razor team
+ *            2013-2014 LXQt team
+ * Authors:
+ *   Petr Vanek <petr@yarpen.cz>
+ *   Alexander Sokoloff <sokoloff.a@gmail.com>
+ *
+ * This program or library is free software; you can redistribute it
+ * and/or modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+
+ * You should have received a copy of the GNU Lesser General
+ * Public License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301 USA
+ *
+ * END_COMMON_COPYRIGHT_HEADER */
+
+#include <QtDBus>
+#include "providers.h"
+
+namespace LxQt {
+
+UDisks2Provider::UDisks2Provider(QObject *parent):
+    MountProvider(parent)
+{
+    QDBusConnection system = QDBusConnection::systemBus();
+
+    if (!system.isConnected())
+    {
+        qDebug() << "UDisks2Provider::UDisks2Provider - not connected - " << mIsValid;
+        return;
+    }
+
+
+    if (!QDBusInterface("org.freedesktop.UDisks2",
+                       "/org/freedesktop/UDisks2",
+                       "org.freedesktop.UDisks2", system).isValid())
+    {
+        qDebug() << "org.freedesktop.UDisks2 - not exists - " << mIsValid;
+        return;
+    }
+
+    system.connect("org.freedesktop.UDisks2",
+                   "/org/freedesktop/UDisks2",
+                   "org.freedesktop.UDisks2",
+                   "InterfacesAdded",
+                   this,
+                   SLOT(dbusDeviceAdded(QDBusObjectPath,QVariantMap)));
+
+    system.connect("org.freedesktop.UDisks2",
+                   "/org/freedesktop/UDisks2",
+                   "org.freedesktop.UDisks2",
+                   "InterfacesRemoved",
+                   this,
+                   SLOT(dbusDeviceRemoved(QDBusObjectPath,QStringList)));
+
+    mIsValid = true;
+    qDebug() << "UDisks2Provider::UDisks2Provider final validity" << mIsValid;
+
+}
+
+void UDisks2Provider::update()
+{
+    qDebug() << "UDisks2Provider::update() called";
+
+    QList<QDBusObjectPath> paths;
+    QDBusMessage call = QDBusMessage::createMethodCall("org.freedesktop.UDisks2",
+                                                       "/org/freedesktop/UDisks2/block_devices",
+                                                       "org.freedesktop.DBus.Introspectable",
+                                                       "Introspect");
+    QDBusPendingReply<QString> reply = QDBusConnection::systemBus().call(call);
+
+    if (!reply.isValid())
+    {
+        qWarning("UDisks2Manager: error: %s", qPrintable(reply.error().name()));
+        return;
+    }
+
+    QXmlStreamReader xml(reply.value());
+    while (!xml.atEnd())
+    {
+        xml.readNext();
+        if (xml.tokenType() == QXmlStreamReader::StartElement && xml.name().toString() == "node" )
+        {
+            QString name = xml.attributes().value("name").toString();
+            if(!name.isEmpty())
+                paths << QDBusObjectPath("/org/freedesktop/UDisks2/block_devices/" + name);
+        }
+    }
+
+    foreach (QDBusObjectPath i, paths)
+    {
+//        qDebug() << "UDisks2Provider::update() path:" << i.path();
+        if (mDevicesByPath.contains(i.path()))
+            dbusDeviceChanged(i);
+        else
+            dbusDeviceAdded(i, QVariantMap());
+    }
+
+//    qDebug() << mDevicesByPath;
+}
+
+UDisks2MountDevice *UDisks2Provider::getDevice(const QDBusObjectPath &path) const
+{
+    if (mDevicesByPath.contains(path.path()))
+        return mDevicesByPath[path.path()];
+    else
+        return 0;
+}
+
+void UDisks2Provider::addDevice(UDisks2MountDevice *device)
+{
+    mDevicesByPath.insert(device->path().path(), device);
+    mDevices.append(device);
+}
+
+void UDisks2Provider::delDevice(UDisks2MountDevice *device)
+{
+    mDevices.removeAll(device);
+    mDevicesByPath.remove(device->path().path());
+    device->deleteLater();
+}
+
+void UDisks2Provider::dbusDeviceAdded(const QDBusObjectPath &path, const QVariantMap &)
+{
+    if(path.path().startsWith("/org/freedesktop/UDisks2/jobs"))
+        return;
+
+    UDisks2MountDevice *device = new UDisks2MountDevice(path);
+
+    addDevice(device);
+    emit deviceAdded(device);
+}
+
+void UDisks2Provider::dbusDeviceRemoved(const QDBusObjectPath &path, const QStringList &)
+{
+    if(path.path().startsWith("/org/freedesktop/UDisks2/jobs"))
+        return;
+
+    UDisks2MountDevice *device = getDevice(path);
+    if (device)
+    {
+        emit deviceRemoved(device);
+        delDevice(device);
+    }
+}
+
+void UDisks2Provider::dbusDeviceChanged(const QDBusObjectPath &path)
+{
+#if 0
+    if(path.path().startsWith("/org/freedesktop/UDisks2/jobs"))
+        return;
+
+    UDisks2MountDevice *device = getDevice(path);
+    if (!device)
+        return;
+
+    if (device->update())
+        emit deviceChanged(device);
+#endif
+}
+
+UDisks2MountDevice::UDisks2MountDevice(const QDBusObjectPath &path):
+    MountDevice(),
+    mPath(path)
+{
+//    qDebug() << "UDisks2MountDevice::UDisks2MountDevice path" << mPath.path();
+    mBlockIface = new QDBusInterface("org.freedesktop.UDisks2",
+                                     mPath.path(),
+                                     "org.freedesktop.UDisks2.Block",
+                                     QDBusConnection::systemBus(),
+                                     this);
+    Q_ASSERT(mBlockIface);
+
+    QDBusObjectPath drive_object = mBlockIface->property("Drive").value<QDBusObjectPath>();
+//    qDebug() << "UDisks2MountDevice::UDisks2MountDevice drive_object" << drive_object.path();
+
+    QDBusConnection::systemBus().connect("org.freedesktop.UDisks2",
+                                         mPath.path(),
+                                         "org.freedesktop.DBus.Properties","PropertiesChanged",
+                                         this,
+                                         SIGNAL(update()));
+
+    mDriveIface = new QDBusInterface("org.freedesktop.UDisks2",
+                                     drive_object.path(),
+                                     "org.freedesktop.UDisks2.Drive",
+                                     QDBusConnection::systemBus(),
+                                     this);
+    Q_ASSERT(mDriveIface);
+
+    update();
+}
+
+void UDisks2MountDevice::update()
+{
+
+    bool res = false;
+    res = setDevFile(mBlockIface->property("Device").toByteArray().data()) || res;
+
+    res = setMediaType(calcMediaType()) || res;
+    res = setLabel(calcLabel()) || res;
+    res = setIsExternal(calcIsExternal()) || res;
+    res = setIconName(calcIconName()) || res;
+
+    QStringList mounts = mountPoints();
+    res = setIsMounted(mounts.count() != 0) || res;
+
+    res = setIsEjectable(mDriveIface->property("Ejectable").toBool()) || res;
+    res = setSize(mBlockIface->property("Size").toULongLong()) || res;
+    res = setVendor(mDriveIface->property("Vendor").toString()) || res;
+    res = setModel(mDriveIface->property("Model").toString()) || res;
+    res = setFileSystem(mBlockIface->property("IdType").toString()) || res;
+
+    if (!mounts.empty())
+        res = setMountPath(mounts.first()) || res;
+
+    if (res)
+        emit changed();
+}
+
+QStringList UDisks2MountDevice::mountPoints() const
+{
+    QStringList points;
+    QDBusMessage message = QDBusMessage::createMethodCall("org.freedesktop.UDisks2",
+                                                          mPath.path(),
+                                                          "org.freedesktop.DBus.Properties",
+                                                          "Get");
+
+    QList<QVariant> args;
+    args << "org.freedesktop.UDisks2.Filesystem" << "MountPoints";
+    message.setArguments(args);
+
+    QDBusMessage reply = QDBusConnection::systemBus().call(message);
+
+    QList<QByteArray> l;
+    foreach (QVariant arg, reply.arguments())
+        arg.value<QDBusVariant>().variant().value<QDBusArgument>() >> l;
+
+    foreach (QByteArray p, l)
+        points.append(p);
+
+    qDebug() << "UDisks2MountDevice::mountPoints()" << points;
+    return points;
+}
+
+MountDevice::MediaType UDisks2MountDevice::calcMediaType()
+{
+    if (mDriveIface->property("Optical").toBool())
+        return MountDevice::MediaTypeOptical;
+
+    const QString media = mDriveIface->property("Media").toString();
+    const QStringList mediaCompat = mDriveIface->property("MediaCompatibility").toStringList();
+    const QString idUsage = mBlockIface->property("IdUsage").toString();
+
+    // TODO/FIXME: how to get it from udisks2?!
+//    if (mDbus->property("DeviceIsDrive").toBool())
+//    {
+        // TODO/FIXME: just guessing...
+        if (mediaCompat.contains("floppy"))
+            return MountDevice::MediaTypeFdd;
+
+        if (idUsage == "filesystem")
+            return MountDevice::MediaTypeDrive;
+
+        return MountDevice::MediaTypeUnknown;
+//    }
+
+//    if (mDbus->property("DeviceIsPartition").toBool())
+//    {
+//        if (idUsage == "filesystem")
+//            return MountDevice::MediaTypePartition;
+
+//      return MountDevice::MediaTypeUnknown;
+//    }
+
+    return MountDevice::MediaTypeUnknown;
+
+}
+
+QString UDisks2MountDevice::calcLabel()
+{
+    const QString idLabel = mBlockIface->property("IdLabel").toString();
+
+    if (mMediaType == MediaTypeFdd)
+        return tr("Floppy drive");
+
+    if (mMediaType == MediaTypeOptical)
+        return idLabel;
+
+
+    const QString driveVendor = mDriveIface->property("Vendor").toString();
+    const QString driveModel  = mDriveIface->property("Model").toString();
+    const qulonglong size = mBlockIface->property("Size").toULongLong();
+
+    QString label;
+    if (!idLabel.isEmpty())
+    {
+        label = idLabel;
+    }
+    else
+    {
+       if (!driveVendor.isEmpty())
+            label = driveVendor;
+
+       if (!driveModel.isEmpty())
+            label += QString(" - %1").arg(driveModel);
+    }
+
+    if (label.isEmpty())
+        label = mDevFile;
+
+    if (mSize)
+        label += QString(" [%3]").arg(sizeToString(size));
+
+    qDebug() << "LABEL" << mPath.path() << label;
+    return label;
+}
+
+bool UDisks2MountDevice::calcIsExternal()
+{
+    // TODO/FIXME: I'm really unsure here...
+    return mDriveIface->property("Removable").toBool();
+}
+
+QString UDisks2MountDevice::calcIconName()
+{
+    const QString media = mDriveIface->property( "Media" ).toString();
+
+    switch (mMediaType)
+    {
+    // ..............................................
+    case MediaTypeDrive:
+    case MediaTypePartition:
+        {
+            // handle drives
+            const QString conn = mDriveIface->property( "ConnectionBus" ).toString();
+
+            if (conn == "usb")
+                return "drive-removable-media-usb";
+
+            return "drive-removable-media";
+        }
+
+    // ..............................................
+    case MediaTypeFdd:
+        {
+            return "media-floppy";
+        }
+
+
+    // ..............................................
+//    case MediaTypeFlash:
+//        {
+//            if ( media == "flash_ms" ) // Flash & Co.
+//                return "media-flash-memory-stick";
+
+//            if ( media == "flash_sd" ||
+//                 media == "flash_sdhc" ||
+//                 media == "flash_mmc" )
+//                return "media-flash-sd-mmc";
+
+//            if ( media == "flash_sm" )
+//                return "media-flash-smart-media";
+
+//            return "media-flash";
+//        }
+
+
+    case MediaTypeOptical:
+        {
+            bool isWritable = mDriveIface->property( "OpticalBlank" ).toBool()
+                                // TODO/FIXME: how in udisks2?
+                             //||
+                             // mDbus->property("OpticalDiscIsAppendable").toBool();
+                                ;
+
+            if (isWritable)
+                return "media-optical-recordable";
+
+            if (media.startsWith("optical_dvd") ||
+                media.startsWith( "optical_hddvd")) // DVD
+                return "media-optical-dvd";
+
+            if (media.startsWith("optical_bd")) // BluRay
+                return "media-optical-blu-ray";
+
+            return "media-optical";
+        }
+
+    case MediaTypeUnknown:
+        {
+            return "drive-harddisk";
+        }
+    }
+
+    return "drive-harddisk";
+}
+
+void UDisks2MountDevice::dbusError(const QDBusError &err, const QDBusMessage &msg)
+{
+    qWarning() << "UDisks2MountDevice::mDbus_error" << err.message();
+    emit error(err.message());
+}
+
+bool UDisks2MountDevice::mount()
+{
+    qDebug() << "MOUNT" << mPath.path();
+
+    QDBusConnection c = QDBusConnection::systemBus();
+    QDBusMessage msg = QDBusMessage::createMethodCall("org.freedesktop.UDisks2",
+                                                      mPath.path(),
+                                                      "org.freedesktop.UDisks2.Filesystem",
+                                                      "Mount");
+    QVariantMap options;
+    if (fileSystem() == "vfat")
+        options.insert("options", "flush");
+
+    msg << options;
+
+    return c.callWithCallback(msg,
+                              this,
+                              SLOT(aboutToMount()),
+                              SLOT(dbusError(QDBusError,QDBusMessage)));
+}
+
+bool UDisks2MountDevice::unmount()
+{
+    qDebug() << "UNMOUNT" << mPath.path();
+
+    if (!mIsMounted)
+        return true;
+
+    QDBusConnection c = QDBusConnection::systemBus();
+    QDBusMessage msg = QDBusMessage::createMethodCall("org.freedesktop.UDisks2",
+                                                      mPath.path(),
+                                                      "org.freedesktop.UDisks2.Filesystem",
+                                                      "Unmount");
+    QVariantMap options;
+    if (fileSystem() == "vfat")
+        options.insert("options", "flush");
+
+    msg << options;
+
+    return c.callWithCallback(msg,
+                              this,
+                              SLOT(aboutToUnmount()),
+                              SLOT(dbusError(QDBusError,QDBusMessage)));
+}
+
+bool UDisks2MountDevice::eject()
+{
+    qDebug() << "EJECT" << mPath.path();
+
+    return mDriveIface->callWithCallback("Eject",
+                                         QVariantList(),
+                                         this,
+                                         SLOT(aboutToEject()),
+                                         SLOT(dbusError(QDBusError,QDBusMessage)));
+}
+
+void UDisks2MountDevice::aboutToMount()
+{
+    update();
+    emit mounted();
+}
+
+void UDisks2MountDevice::aboutToUnmount()
+{
+    update();
+    emit unmounted();
+}
+
+void UDisks2MountDevice::aboutToEject()
+{
+    qDebug() << "UDisks2MountDevice::aboutToEject success";
+}
+
+} // namespace LxQt

=== removed file 'rzmountproviders.cpp'
--- rzmountproviders.cpp	2014-05-06 08:07:57 +0000
+++ rzmountproviders.cpp	1970-01-01 00:00:00 +0000
@@ -1,511 +0,0 @@
-/* BEGIN_COMMON_COPYRIGHT_HEADER
- * (c)LGPL2+
- *
- * LXQt - The Lightweight Desktop Environment
- * http://lxqt.org
- *
- * Copyright: 2012 Razor team
- *            2013-2014 LXQt team
- * Authors:
- *   Alexander Sokoloff <sokoloff.a@gmail.com>
- *   Petr Vanek <petr@scribus.info>
- *
- * This program or library is free software; you can redistribute it
- * and/or modify it under the terms of the GNU Lesser General Public
- * License as published by the Free Software Foundation; either
- * version 2.1 of the License, or (at your option) any later version.
- *
- * This library is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * Lesser General Public License for more details.
-
- * You should have received a copy of the GNU Lesser General
- * Public License along with this library; if not, write to the
- * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- * Boston, MA 02110-1301 USA
- *
- * END_COMMON_COPYRIGHT_HEADER */
-
-#include "rzmountproviders.h"
-#include <QtDBus/QDBusConnection>
-#include <QtDBus/QDBusArgument>
-#include <QtDBus/QDBusInterface>
-#include <QtDBus/QDBusMessage>
-#include <QtCore/QDebug>
-
-namespace LxQt {
-
-/************************************************
-
- ************************************************/
-MountProvider::MountProvider(QObject *parent):
-    QObject(parent),
-    mIsValid(false)
-{
-}
-
-
-/************************************************
-
- ************************************************/
-UDiskProvider::UDiskProvider(QObject *parent):
-    MountProvider(parent)
-{
-    QDBusConnection system = QDBusConnection::systemBus();
-
-    if (!system.isConnected())
-    {
-        return;
-    }
-
-    if (!QDBusInterface("org.freedesktop.UDisks",
-                       "/org/freedesktop/UDisks",
-                       "org.freedesktop.UDisks", system).isValid())
-    {
-        qDebug() << "org.freedesktop.UDisks - not exists - " << mIsValid;
-        return;
-    }
-
-    system.connect("org.freedesktop.UDisks",
-                   "/org/freedesktop/UDisks",
-                   "org.freedesktop.UDisks",
-                   "DeviceAdded",
-                   this,
-                   SLOT(dbusDeviceAdded(QDBusObjectPath)));
-
-    system.connect("org.freedesktop.UDisks",
-                   "/org/freedesktop/UDisks",
-                   "org.freedesktop.UDisks",
-                   "DeviceRemoved",
-                   this,
-                   SLOT(dbusDeviceRemoved(QDBusObjectPath)));
-
-    system.connect("org.freedesktop.UDisks",
-                   "/org/freedesktop/UDisks",
-                   "org.freedesktop.UDisks",
-                   "DeviceChanged",
-                   this,
-                   SLOT(dbusDeviceChanged(QDBusObjectPath)));
-
-    mIsValid = true;
-}
-
-
-/************************************************
-
- ************************************************/
-void UDiskProvider::update()
-{
-
-    QDBusInterface devEnum("org.freedesktop.UDisks",
-                           "/org/freedesktop/UDisks",
-                           "org.freedesktop.UDisks",
-                           QDBusConnection::systemBus());
-
-    QDBusMessage enumRes = devEnum.call("EnumerateDevices");
-    if (enumRes.type() != QDBusMessage::ReplyMessage || !enumRes.arguments().at(0).canConvert<QDBusArgument>())
-    {
-        if (enumRes.type() == QDBusMessage::ErrorMessage)
-            qWarning() << "ERROR: Can't call EnumerateDevices"
-                       <<  qPrintable(enumRes.errorName()) << qPrintable(enumRes.errorMessage());
-        else
-            qWarning() << "ERROR: Unexpected result type of EnumerateDevices call";
-        return;
-    }
-
-    const QDBusArgument enumArg = enumRes.arguments().at(0).value<QDBusArgument>();
-    if (enumArg.currentType() != QDBusArgument::ArrayType)
-    {
-        qWarning() << "ERROR: Unexpected argument type of EnumerateDevices call";
-        return;
-    }
-
-    enumArg.beginArray();
-    while (!enumArg.atEnd())
-    {
-        QDBusObjectPath path = qdbus_cast<QDBusObjectPath>(enumArg);
-
-        if (mDevicesByPath.contains(path.path()))
-            dbusDeviceChanged(path);
-        else
-            dbusDeviceAdded(path);
-    }
-    enumArg.endArray();
-
-}
-
-
-/************************************************
-
- ************************************************/
-UDiskMountDevice *UDiskProvider::getDevice(const QDBusObjectPath &path) const
-{
-    if (mDevicesByPath.contains(path.path()))
-        return mDevicesByPath[path.path()];
-    else
-        return 0;
-}
-
-
-/************************************************
-
- ************************************************/
-void UDiskProvider::addDevice(UDiskMountDevice *device)
-{
-    mDevicesByPath.insert(device->udiskPath(), device);
-    mDevices.append(device);
-}
-
-
-/************************************************
-
- ************************************************/
-void UDiskProvider::delDevice(UDiskMountDevice *device)
-{
-    mDevices.removeAll(device);
-    mDevicesByPath.remove(device->udiskPath());
-    device->deleteLater();
-}
-
-
-/************************************************
-
- ************************************************/
-void UDiskProvider::dbusDeviceAdded(const QDBusObjectPath &path)
-{
-    UDiskMountDevice *device = new UDiskMountDevice(path);
-     addDevice(device);
-     emit deviceAdded(device);
-}
-
-
-/************************************************
-
- ************************************************/
-void UDiskProvider::dbusDeviceRemoved(const QDBusObjectPath &path)
-{
-    UDiskMountDevice *device = getDevice(path);
-    if (device)
-    {
-        emit deviceRemoved(device);
-        delDevice(device);
-    }
-}
-
-
-/************************************************
-
- ************************************************/
-void UDiskProvider::dbusDeviceChanged(const QDBusObjectPath &path)
-{
-    UDiskMountDevice *device = getDevice(path);
-    if (!device)
-        return;
-
-    if (device->update())
-        emit deviceChanged(device);
-}
-
-
-/************************************************
-
- ************************************************/
-UDiskMountDevice::UDiskMountDevice(const QDBusObjectPath &path):
-    MountDevice(),
-    mUdiskPath(path.path())
-{
-    mDbus = new QDBusInterface("org.freedesktop.UDisks",
-                               path.path(),
-                               "org.freedesktop.UDisks.Device",
-                               QDBusConnection::systemBus(),
-                               this);
-    update();
-}
-
-
-/************************************************
-
- ************************************************/
-bool UDiskMountDevice::update()
-{
-    bool res = false;
-    res = setDevFile(mDbus->property("DeviceFile").toString()) || res;
-
-    res = setMediaType(calcMediaType()) || res;
-    res = setLabel(calcLabel()) || res;
-    res = setIsExternal(calcIsExternal()) || res;
-    res = setIconName(calcIconName()) || res;
-
-    res = setIsMounted(mDbus->property("DeviceIsMounted").toBool()) || res;
-
-    if (mDbus->property("DeviceIsDrive").toBool())
-        res = setIsEjectable(mDbus->property("DriveIsMediaEjectable").toBool());
-
-    res = setSize(mDbus->property("DeviceSize").toULongLong()) || res;
-    res = setVendor(mDbus->property("DriveVendor").toString()) || res;
-    res = setModel(mDbus->property("DriveModel").toString()) || res;
-    res = setFileSystem(mDbus->property("IdType").toString()) || res;
-
-    QStringList paths = mDbus->property("DeviceMountPaths").toStringList();
-    if (!paths.empty())
-        res = setMountPath(paths.first()) || res;
-
-    if (res)
-        emit changed();
-
-    return res;
-}
-
-
-/************************************************
-
- ************************************************/
-MountDevice::MediaType UDiskMountDevice::calcMediaType()
-{
-    if (mDbus->property("DeviceIsOpticalDisc").toBool())
-        return MountDevice::MediaTypeOptical;
-
-    const QString media = mDbus->property("DriveMedia").toString();
-    const QString mediaCompat = mDbus->property("DriveMediaCompatibility").toString();
-    const QString idUsage = mDbus->property("IdUsage").toString();
-
-    if (mDbus->property("DeviceIsDrive").toBool())
-    {
-        if (mediaCompat == "floppy")
-            return MountDevice::MediaTypeFdd;
-
-        if (idUsage == "filesystem")
-            return MountDevice::MediaTypeDrive;
-
-        return MountDevice::MediaTypeUnknown;
-    }
-
-    if (mDbus->property("DeviceIsPartition").toBool())
-    {
-        if (idUsage == "filesystem")
-            return MountDevice::MediaTypePartition;
-
-        return MountDevice::MediaTypeUnknown;
-    }
-
-    return MountDevice::MediaTypeUnknown;
-}
-
-
-/************************************************
-
- ************************************************/
-QString UDiskMountDevice::calcLabel()
-{
-    const QString idLabel = mDbus->property("IdLabel").toString();
-
-    if (mMediaType ==  MediaTypeFdd)
-        return tr("Floppy drive");
-
-    if (mMediaType ==  MediaTypeOptical)
-        return idLabel;
-
-
-    const QString driveVendor = mDbus->property("DriveVendor").toString();
-    const QString driveModel  = mDbus->property("DriveModel").toString();
-    const qulonglong size = mDbus->property("DeviceSize").toULongLong();
-
-    QString label;
-    if (!idLabel.isEmpty())
-    {
-        label = idLabel;
-    }
-    else
-    {
-       if (!driveVendor.isEmpty())
-            label = driveVendor;
-
-       if (!driveModel.isEmpty())
-            label += QString(" - %1").arg(driveModel);
-    }
-
-    if (label.isEmpty())
-        label = mDevFile;
-
-    if (mSize)
-        label += QString(" [%3]").arg(sizeToString(size));
-
-    return label;
-}
-
-
-/************************************************
-
- ************************************************/
-bool UDiskMountDevice::calcIsExternal()
-{
-    return ! mDbus->property("DeviceIsSystemInternal").toBool();
-//    if (mDbus->property("DeviceIsSystemInternal").toBool())
-//        return false;
-
-//    if (mDbus->property("DeviceIsMediaAvailable").toBool()
-//        && mDbus->property("IdUsage").toString() == "filesystem")
-//        return true;
-
-//    if (mDbus->property("DeviceIsDrive").toBool())
-//    {
-//        return true;
-//    }
-
- //   return false;
-}
-
-
-/************************************************
-
- ************************************************/
-QString UDiskMountDevice::calcIconName()
-{
-    const QString media = mDbus->property( "DriveMedia" ).toString();
-
-    switch (mMediaType)
-    {
-    // ..............................................
-    case MediaTypeDrive:
-    case MediaTypePartition:
-        {
-            // handle drives
-            const QString conn = mDbus->property( "DriveConnectionInterface" ).toString();
-
-            if (conn == "usb")
-                return "drive-removable-media-usb";
-
-            return "drive-removable-media";
-        }
-
-    // ..............................................
-    case MediaTypeFdd:
-        {
-            return "media-floppy";
-        }
-
-
-    // ..............................................
-//    case MediaTypeFlash:
-//        {
-//            if ( media == "flash_ms" ) // Flash & Co.
-//                return "media-flash-memory-stick";
-
-//            if ( media == "flash_sd" ||
-//                 media == "flash_sdhc" ||
-//                 media == "flash_mmc" )
-//                return "media-flash-sd-mmc";
-
-//            if ( media == "flash_sm" )
-//                return "media-flash-smart-media";
-
-//            return "media-flash";
-//        }
-
-
-    // ..............................................
-    case MediaTypeOptical:
-        {
-            bool isWritable = mDbus->property( "OpticalDiscIsBlank" ).toBool() ||
-                              mDbus->property("OpticalDiscIsAppendable").toBool();
-
-            if (isWritable)
-                return "media-optical-recordable";
-
-            if (media.startsWith("optical_dvd") ||
-                media.startsWith( "optical_hddvd")) // DVD
-                return "media-optical-dvd";
-
-            if (media.startsWith("optical_bd")) // BluRay
-                return "media-optical-blu-ray";
-
-            return "media-optical";
-        }
-
-    // ..............................................
-    case MediaTypeUnknown:
-        {
-            return "drive-harddisk";
-        }
-    }
-
-     return "drive-harddisk";
-}
-
-
-/************************************************
-
- ************************************************/
-void UDiskMountDevice::dbusError(const QDBusError &err, const QDBusMessage &msg)
-{
-    qWarning() << "UdisksInfo::mDbus_error" << err.message();
-    emit error(err.message());
-}
-
-
-/************************************************
-
- ************************************************/
-bool UDiskMountDevice::mount()
-{
-    if (mIsMounted)
-        return true;
-
-    QList<QVariant> args;
-    args << QVariant(QString()) << QVariant(QStringList());
-
-    bool ret;
-    ret = mDbus->callWithCallback("FilesystemMount", args, this,
-                             //SLOT(dbusSuccess(QDBusMessage)),
-                             SIGNAL(mounted()),
-                             SLOT(dbusError(QDBusError, QDBusMessage)));
-
-    QStringList paths = mDbus->property("DeviceMountPaths").toStringList();
-
-    if (!paths.empty())
-        mMountPath = paths.at(0);
-    else
-        mMountPath = "";
-
-    return ret;
-}
-
-
-/************************************************
-
- ************************************************/
-bool UDiskMountDevice::unmount()
-{
-    if (!mIsMounted)
-        return true;
-
-    QList<QVariant> args;
-    args << QVariant(QStringList());
-
-    bool ret;
-    ret = mDbus->callWithCallback("FilesystemUnmount", args, this,
-//                             SLOT(dbusSuccess(QDBusMessage)),
-                             SIGNAL(unmounted()),
-                             SLOT(dbusError(QDBusError, QDBusMessage)));
-    return ret;
-}
-
-
-/************************************************
-
- ************************************************/
-bool UDiskMountDevice::eject()
-{
-    if (!mIsMounted)
-        return false;
-
-    QList<QVariant> args;
-    args << QVariant(QStringList());
-
-    return mDbus->callWithCallback("DriveEject", args, this,
-                             SLOT(dbusSuccess(QDBusMessage)),
-                             SLOT(dbusError(QDBusError, QDBusMessage)));
-}
-
-} // namespace LxQt

=== removed file 'rzmountproviders.h'
--- rzmountproviders.h	2014-05-06 08:07:57 +0000
+++ rzmountproviders.h	1970-01-01 00:00:00 +0000
@@ -1,175 +0,0 @@
-/* BEGIN_COMMON_COPYRIGHT_HEADER
- * (c)LGPL2+
- *
- * LXQt - The Lightweight Desktop Environment
- * http://lxqt.org
- *
- * Copyright: 2012 Razor team
- *            2013-2014 LXQt team
- * Authors:
- *   Alexander Sokoloff <sokoloff.a@gmail.com>
- *   Petr Vanek <petr@scribus.info>
- *
- * This program or library is free software; you can redistribute it
- * and/or modify it under the terms of the GNU Lesser General Public
- * License as published by the Free Software Foundation; either
- * version 2.1 of the License, or (at your option) any later version.
- *
- * This library is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * Lesser General Public License for more details.
-
- * You should have received a copy of the GNU Lesser General
- * Public License along with this library; if not, write to the
- * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- * Boston, MA 02110-1301 USA
- *
- * END_COMMON_COPYRIGHT_HEADER */
-
-
-#ifndef LXQTMOUNT_RZMOUNTPROVIDERS_H
-#define LXQTMOUNT_RZMOUNTPROVIDERS_H
-
-#include <QObject>
-#include "lxqtmount.h"
-#include <QtDBus/QDBusObjectPath>
-class QDBusInterface;
-class QDBusMessage;
-class QDBusError;
-
-namespace LxQt {
-
-class MountProvider : public QObject
-{
-    Q_OBJECT
-public:
-    explicit MountProvider(QObject *parent = 0);
-    virtual ~MountProvider() {}
-
-    const MountDeviceList devices() const { return mDevices; }
-
-    bool isValid() const { return mIsValid; }
-    virtual void update()=0;
-
-signals:
-    void deviceAdded(LxQt::MountDevice *device);
-    void deviceRemoved(LxQt::MountDevice *device);
-    void deviceChanged(LxQt::MountDevice *device);
-
-protected:
-    MountDeviceList mDevices;
-    bool mIsValid;
-};
-
-
-
-class UDiskMountDevice: public MountDevice
-{
-    Q_OBJECT
-public:
-    UDiskMountDevice(const QDBusObjectPath &path);
-    bool update();
-    QString udiskPath() const { return mUdiskPath; }
-
-    virtual bool mount();
-    virtual bool unmount();
-    virtual bool eject();
-
-private:
-    QDBusInterface *mDbus;
-    QString mUdiskPath;
-
-    MediaType calcMediaType();
-    QString calcLabel();
-    bool calcIsExternal();
-    QString calcIconName();
-
-private slots:
-    void dbusError(const QDBusError &err, const QDBusMessage &msg);
-};
-
-
-
-class UDiskProvider: public MountProvider
-{
-    Q_OBJECT
-public:
-    explicit UDiskProvider(QObject *parent = 0);
-
-    virtual void update();
-
-private slots:
-    void dbusDeviceAdded(const QDBusObjectPath &path);
-    void dbusDeviceRemoved(const QDBusObjectPath &path);
-    void dbusDeviceChanged(const QDBusObjectPath &path);
-
-private:
-    QHash<QString, UDiskMountDevice*> mDevicesByPath;
-    UDiskMountDevice *getDevice(const QDBusObjectPath &path) const;
-
-    void addDevice(UDiskMountDevice *device);
-    void delDevice(UDiskMountDevice *device);
-};
-
-
-
-class UDisks2MountDevice: public MountDevice
-{
-    Q_OBJECT
-public:
-    UDisks2MountDevice(const QDBusObjectPath &path);
-    QDBusObjectPath path() { return mPath; }
-
-    virtual bool mount();
-    virtual bool unmount();
-    virtual bool eject();
-
-private:
-    QDBusInterface *mBlockIface;
-    QDBusInterface *mDriveIface;
-    QDBusObjectPath mPath;
-
-    MediaType calcMediaType();
-    QString calcLabel();
-    bool calcIsExternal();
-    QString calcIconName();
-    QStringList mountPoints() const;
-
-
-private slots:
-    void dbusError(const QDBusError &err, const QDBusMessage &msg);
-    void aboutToMount();
-    void aboutToUnmount();
-    void aboutToEject();
-    void update();
-};
-
-
-
-class UDisks2Provider: public MountProvider
-{
-    Q_OBJECT
-public:
-    explicit UDisks2Provider(QObject *parent = 0);
-
-    virtual void update();
-
-public slots:
-    void dbusDeviceChanged(const QDBusObjectPath &path);
-
-private slots:
-    void dbusDeviceAdded(const QDBusObjectPath &path, const QVariantMap &map);
-    void dbusDeviceRemoved(const QDBusObjectPath &path, const QStringList &list);
-
-private:
-    QHash<QString, UDisks2MountDevice*> mDevicesByPath;
-    UDisks2MountDevice *getDevice(const QDBusObjectPath &path) const;
-
-    void addDevice(UDisks2MountDevice *device);
-    void delDevice(UDisks2MountDevice *device);
-};
-
-} // namespace LxQt
-
-#endif // LXQTMOUNT_RZMOUNTPROVIDERS_H

=== removed file 'rzmountproviders_udisks2.cpp'
--- rzmountproviders_udisks2.cpp	2014-05-06 08:07:57 +0000
+++ rzmountproviders_udisks2.cpp	1970-01-01 00:00:00 +0000
@@ -1,490 +0,0 @@
-/* BEGIN_COMMON_COPYRIGHT_HEADER
- * (c)LGPL2+
- *
- * LXQt - The Lightweight Desktop Environment
- * http://lxqt.org
- *
- * Copyright: 2013 Razor team
- *            2013-2014 LXQt team
- * Authors:
- *   Petr Vanek <petr@yarpen.cz>
- *   Alexander Sokoloff <sokoloff.a@gmail.com>
- *
- * This program or library is free software; you can redistribute it
- * and/or modify it under the terms of the GNU Lesser General Public
- * License as published by the Free Software Foundation; either
- * version 2.1 of the License, or (at your option) any later version.
- *
- * This library is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * Lesser General Public License for more details.
-
- * You should have received a copy of the GNU Lesser General
- * Public License along with this library; if not, write to the
- * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- * Boston, MA 02110-1301 USA
- *
- * END_COMMON_COPYRIGHT_HEADER */
-
-#include <QtDBus>
-#include "rzmountproviders.h"
-
-namespace LxQt {
-
-UDisks2Provider::UDisks2Provider(QObject *parent):
-    MountProvider(parent)
-{
-    QDBusConnection system = QDBusConnection::systemBus();
-
-    if (!system.isConnected())
-    {
-        qDebug() << "UDisks2Provider::UDisks2Provider - not connected - " << mIsValid;
-        return;
-    }
-
-
-    if (!QDBusInterface("org.freedesktop.UDisks2",
-                       "/org/freedesktop/UDisks2",
-                       "org.freedesktop.UDisks2", system).isValid())
-    {
-        qDebug() << "org.freedesktop.UDisks2 - not exists - " << mIsValid;
-        return;
-    }
-
-    system.connect("org.freedesktop.UDisks2",
-                   "/org/freedesktop/UDisks2",
-                   "org.freedesktop.UDisks2",
-                   "InterfacesAdded",
-                   this,
-                   SLOT(dbusDeviceAdded(QDBusObjectPath,QVariantMap)));
-
-    system.connect("org.freedesktop.UDisks2",
-                   "/org/freedesktop/UDisks2",
-                   "org.freedesktop.UDisks2",
-                   "InterfacesRemoved",
-                   this,
-                   SLOT(dbusDeviceRemoved(QDBusObjectPath,QStringList)));
-
-    mIsValid = true;
-    qDebug() << "UDisks2Provider::UDisks2Provider final validity" << mIsValid;
-
-}
-
-void UDisks2Provider::update()
-{
-    qDebug() << "UDisks2Provider::update() called";
-
-    QList<QDBusObjectPath> paths;
-    QDBusMessage call = QDBusMessage::createMethodCall("org.freedesktop.UDisks2",
-                                                       "/org/freedesktop/UDisks2/block_devices",
-                                                       "org.freedesktop.DBus.Introspectable",
-                                                       "Introspect");
-    QDBusPendingReply<QString> reply = QDBusConnection::systemBus().call(call);
-
-    if (!reply.isValid())
-    {
-        qWarning("UDisks2Manager: error: %s", qPrintable(reply.error().name()));
-        return;
-    }
-
-    QXmlStreamReader xml(reply.value());
-    while (!xml.atEnd())
-    {
-        xml.readNext();
-        if (xml.tokenType() == QXmlStreamReader::StartElement && xml.name().toString() == "node" )
-        {
-            QString name = xml.attributes().value("name").toString();
-            if(!name.isEmpty())
-                paths << QDBusObjectPath("/org/freedesktop/UDisks2/block_devices/" + name);
-        }
-    }
-
-    foreach (QDBusObjectPath i, paths)
-    {
-//        qDebug() << "UDisks2Provider::update() path:" << i.path();
-        if (mDevicesByPath.contains(i.path()))
-            dbusDeviceChanged(i);
-        else
-            dbusDeviceAdded(i, QVariantMap());
-    }
-
-//    qDebug() << mDevicesByPath;
-}
-
-UDisks2MountDevice *UDisks2Provider::getDevice(const QDBusObjectPath &path) const
-{
-    if (mDevicesByPath.contains(path.path()))
-        return mDevicesByPath[path.path()];
-    else
-        return 0;
-}
-
-void UDisks2Provider::addDevice(UDisks2MountDevice *device)
-{
-    mDevicesByPath.insert(device->path().path(), device);
-    mDevices.append(device);
-}
-
-void UDisks2Provider::delDevice(UDisks2MountDevice *device)
-{
-    mDevices.removeAll(device);
-    mDevicesByPath.remove(device->path().path());
-    device->deleteLater();
-}
-
-void UDisks2Provider::dbusDeviceAdded(const QDBusObjectPath &path, const QVariantMap &)
-{
-    if(path.path().startsWith("/org/freedesktop/UDisks2/jobs"))
-        return;
-
-    UDisks2MountDevice *device = new UDisks2MountDevice(path);
-
-    addDevice(device);
-    emit deviceAdded(device);
-}
-
-void UDisks2Provider::dbusDeviceRemoved(const QDBusObjectPath &path, const QStringList &)
-{
-    if(path.path().startsWith("/org/freedesktop/UDisks2/jobs"))
-        return;
-
-    UDisks2MountDevice *device = getDevice(path);
-    if (device)
-    {
-        emit deviceRemoved(device);
-        delDevice(device);
-    }
-}
-
-void UDisks2Provider::dbusDeviceChanged(const QDBusObjectPath &path)
-{
-#if 0
-    if(path.path().startsWith("/org/freedesktop/UDisks2/jobs"))
-        return;
-
-    UDisks2MountDevice *device = getDevice(path);
-    if (!device)
-        return;
-
-    if (device->update())
-        emit deviceChanged(device);
-#endif
-}
-
-UDisks2MountDevice::UDisks2MountDevice(const QDBusObjectPath &path):
-    MountDevice(),
-    mPath(path)
-{
-//    qDebug() << "UDisks2MountDevice::UDisks2MountDevice path" << mPath.path();
-    mBlockIface = new QDBusInterface("org.freedesktop.UDisks2",
-                                     mPath.path(),
-                                     "org.freedesktop.UDisks2.Block",
-                                     QDBusConnection::systemBus(),
-                                     this);
-    Q_ASSERT(mBlockIface);
-
-    QDBusObjectPath drive_object = mBlockIface->property("Drive").value<QDBusObjectPath>();
-//    qDebug() << "UDisks2MountDevice::UDisks2MountDevice drive_object" << drive_object.path();
-
-    QDBusConnection::systemBus().connect("org.freedesktop.UDisks2",
-                                         mPath.path(),
-                                         "org.freedesktop.DBus.Properties","PropertiesChanged",
-                                         this,
-                                         SIGNAL(update()));
-
-    mDriveIface = new QDBusInterface("org.freedesktop.UDisks2",
-                                     drive_object.path(),
-                                     "org.freedesktop.UDisks2.Drive",
-                                     QDBusConnection::systemBus(),
-                                     this);
-    Q_ASSERT(mDriveIface);
-
-    update();
-}
-
-void UDisks2MountDevice::update()
-{
-
-    bool res = false;
-    res = setDevFile(mBlockIface->property("Device").toByteArray().data()) || res;
-
-    res = setMediaType(calcMediaType()) || res;
-    res = setLabel(calcLabel()) || res;
-    res = setIsExternal(calcIsExternal()) || res;
-    res = setIconName(calcIconName()) || res;
-
-    QStringList mounts = mountPoints();
-    res = setIsMounted(mounts.count() != 0) || res;
-
-    res = setIsEjectable(mDriveIface->property("Ejectable").toBool()) || res;
-    res = setSize(mBlockIface->property("Size").toULongLong()) || res;
-    res = setVendor(mDriveIface->property("Vendor").toString()) || res;
-    res = setModel(mDriveIface->property("Model").toString()) || res;
-    res = setFileSystem(mBlockIface->property("IdType").toString()) || res;
-
-    if (!mounts.empty())
-        res = setMountPath(mounts.first()) || res;
-
-    if (res)
-        emit changed();
-}
-
-QStringList UDisks2MountDevice::mountPoints() const
-{
-    QStringList points;
-    QDBusMessage message = QDBusMessage::createMethodCall("org.freedesktop.UDisks2",
-                                                          mPath.path(),
-                                                          "org.freedesktop.DBus.Properties",
-                                                          "Get");
-
-    QList<QVariant> args;
-    args << "org.freedesktop.UDisks2.Filesystem" << "MountPoints";
-    message.setArguments(args);
-
-    QDBusMessage reply = QDBusConnection::systemBus().call(message);
-
-    QList<QByteArray> l;
-    foreach (QVariant arg, reply.arguments())
-        arg.value<QDBusVariant>().variant().value<QDBusArgument>() >> l;
-
-    foreach (QByteArray p, l)
-        points.append(p);
-
-    qDebug() << "UDisks2MountDevice::mountPoints()" << points;
-    return points;
-}
-
-MountDevice::MediaType UDisks2MountDevice::calcMediaType()
-{
-    if (mDriveIface->property("Optical").toBool())
-        return MountDevice::MediaTypeOptical;
-
-    const QString media = mDriveIface->property("Media").toString();
-    const QStringList mediaCompat = mDriveIface->property("MediaCompatibility").toStringList();
-    const QString idUsage = mBlockIface->property("IdUsage").toString();
-
-    // TODO/FIXME: how to get it from udisks2?!
-//    if (mDbus->property("DeviceIsDrive").toBool())
-//    {
-        // TODO/FIXME: just guessing...
-        if (mediaCompat.contains("floppy"))
-            return MountDevice::MediaTypeFdd;
-
-        if (idUsage == "filesystem")
-            return MountDevice::MediaTypeDrive;
-
-        return MountDevice::MediaTypeUnknown;
-//    }
-
-//    if (mDbus->property("DeviceIsPartition").toBool())
-//    {
-//        if (idUsage == "filesystem")
-//            return MountDevice::MediaTypePartition;
-
-//      return MountDevice::MediaTypeUnknown;
-//    }
-
-    return MountDevice::MediaTypeUnknown;
-
-}
-
-QString UDisks2MountDevice::calcLabel()
-{
-    const QString idLabel = mBlockIface->property("IdLabel").toString();
-
-    if (mMediaType == MediaTypeFdd)
-        return tr("Floppy drive");
-
-    if (mMediaType == MediaTypeOptical)
-        return idLabel;
-
-
-    const QString driveVendor = mDriveIface->property("Vendor").toString();
-    const QString driveModel  = mDriveIface->property("Model").toString();
-    const qulonglong size = mBlockIface->property("Size").toULongLong();
-
-    QString label;
-    if (!idLabel.isEmpty())
-    {
-        label = idLabel;
-    }
-    else
-    {
-       if (!driveVendor.isEmpty())
-            label = driveVendor;
-
-       if (!driveModel.isEmpty())
-            label += QString(" - %1").arg(driveModel);
-    }
-
-    if (label.isEmpty())
-        label = mDevFile;
-
-    if (mSize)
-        label += QString(" [%3]").arg(sizeToString(size));
-
-    qDebug() << "LABEL" << mPath.path() << label;
-    return label;
-}
-
-bool UDisks2MountDevice::calcIsExternal()
-{
-    // TODO/FIXME: I'm really unsure here...
-    return mDriveIface->property("Removable").toBool();
-}
-
-QString UDisks2MountDevice::calcIconName()
-{
-    const QString media = mDriveIface->property( "Media" ).toString();
-
-    switch (mMediaType)
-    {
-    // ..............................................
-    case MediaTypeDrive:
-    case MediaTypePartition:
-        {
-            // handle drives
-            const QString conn = mDriveIface->property( "ConnectionBus" ).toString();
-
-            if (conn == "usb")
-                return "drive-removable-media-usb";
-
-            return "drive-removable-media";
-        }
-
-    // ..............................................
-    case MediaTypeFdd:
-        {
-            return "media-floppy";
-        }
-
-
-    // ..............................................
-//    case MediaTypeFlash:
-//        {
-//            if ( media == "flash_ms" ) // Flash & Co.
-//                return "media-flash-memory-stick";
-
-//            if ( media == "flash_sd" ||
-//                 media == "flash_sdhc" ||
-//                 media == "flash_mmc" )
-//                return "media-flash-sd-mmc";
-
-//            if ( media == "flash_sm" )
-//                return "media-flash-smart-media";
-
-//            return "media-flash";
-//        }
-
-
-    case MediaTypeOptical:
-        {
-            bool isWritable = mDriveIface->property( "OpticalBlank" ).toBool()
-                                // TODO/FIXME: how in udisks2?
-                             //||
-                             // mDbus->property("OpticalDiscIsAppendable").toBool();
-                                ;
-
-            if (isWritable)
-                return "media-optical-recordable";
-
-            if (media.startsWith("optical_dvd") ||
-                media.startsWith( "optical_hddvd")) // DVD
-                return "media-optical-dvd";
-
-            if (media.startsWith("optical_bd")) // BluRay
-                return "media-optical-blu-ray";
-
-            return "media-optical";
-        }
-
-    case MediaTypeUnknown:
-        {
-            return "drive-harddisk";
-        }
-    }
-
-    return "drive-harddisk";
-}
-
-void UDisks2MountDevice::dbusError(const QDBusError &err, const QDBusMessage &msg)
-{
-    qWarning() << "UDisks2MountDevice::mDbus_error" << err.message();
-    emit error(err.message());
-}
-
-bool UDisks2MountDevice::mount()
-{
-    qDebug() << "MOUNT" << mPath.path();
-
-    QDBusConnection c = QDBusConnection::systemBus();
-    QDBusMessage msg = QDBusMessage::createMethodCall("org.freedesktop.UDisks2",
-                                                      mPath.path(),
-                                                      "org.freedesktop.UDisks2.Filesystem",
-                                                      "Mount");
-    QVariantMap options;
-    if (fileSystem() == "vfat")
-        options.insert("options", "flush");
-
-    msg << options;
-
-    return c.callWithCallback(msg,
-                              this,
-                              SLOT(aboutToMount()),
-                              SLOT(dbusError(QDBusError,QDBusMessage)));
-}
-
-bool UDisks2MountDevice::unmount()
-{
-    qDebug() << "UNMOUNT" << mPath.path();
-
-    if (!mIsMounted)
-        return true;
-
-    QDBusConnection c = QDBusConnection::systemBus();
-    QDBusMessage msg = QDBusMessage::createMethodCall("org.freedesktop.UDisks2",
-                                                      mPath.path(),
-                                                      "org.freedesktop.UDisks2.Filesystem",
-                                                      "Unmount");
-    QVariantMap options;
-    if (fileSystem() == "vfat")
-        options.insert("options", "flush");
-
-    msg << options;
-
-    return c.callWithCallback(msg,
-                              this,
-                              SLOT(aboutToUnmount()),
-                              SLOT(dbusError(QDBusError,QDBusMessage)));
-}
-
-bool UDisks2MountDevice::eject()
-{
-    qDebug() << "EJECT" << mPath.path();
-
-    return mDriveIface->callWithCallback("Eject",
-                                         QVariantList(),
-                                         this,
-                                         SLOT(aboutToEject()),
-                                         SLOT(dbusError(QDBusError,QDBusMessage)));
-}
-
-void UDisks2MountDevice::aboutToMount()
-{
-    update();
-    emit mounted();
-}
-
-void UDisks2MountDevice::aboutToUnmount()
-{
-    update();
-    emit unmounted();
-}
-
-void UDisks2MountDevice::aboutToEject()
-{
-    qDebug() << "UDisks2MountDevice::aboutToEject success";
-}
-
-} // namespace LxQt

